// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::{Bin, DockManager};
use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlDockWidget")]
    pub struct DockWidget(Object<ffi::DzlDockWidget, ffi::DzlDockWidgetClass>) @extends Bin, gtk::Bin, gtk::Container, gtk::Widget, @implements gtk::Buildable;

    match fn {
        type_ => || ffi::dzl_dock_widget_get_type(),
    }
}

impl DockWidget {
    pub const NONE: Option<&'static DockWidget> = None;

    #[doc(alias = "dzl_dock_widget_new")]
    pub fn new() -> DockWidget {
        assert_initialized_main_thread!();
        unsafe { gtk::Widget::from_glib_none(ffi::dzl_dock_widget_new()).unsafe_cast() }
    }
}

impl Default for DockWidget {
    fn default() -> Self {
        Self::new()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::DockWidget>> Sealed for T {}
}

pub trait DockWidgetExt: IsA<DockWidget> + sealed::Sealed + 'static {
    #[doc(alias = "dzl_dock_widget_set_gicon")]
    fn set_gicon(&self, gicon: &impl IsA<gio::Icon>) {
        unsafe {
            ffi::dzl_dock_widget_set_gicon(
                self.as_ref().to_glib_none().0,
                gicon.as_ref().to_glib_none().0,
            );
        }
    }

    #[doc(alias = "dzl_dock_widget_set_icon_name")]
    fn set_icon_name(&self, icon_name: &str) {
        unsafe {
            ffi::dzl_dock_widget_set_icon_name(
                self.as_ref().to_glib_none().0,
                icon_name.to_glib_none().0,
            );
        }
    }

    #[doc(alias = "dzl_dock_widget_set_title")]
    fn set_title(&self, title: &str) {
        unsafe {
            ffi::dzl_dock_widget_set_title(self.as_ref().to_glib_none().0, title.to_glib_none().0);
        }
    }

    #[doc(alias = "can-close")]
    fn can_close(&self) -> bool {
        ObjectExt::property(self.as_ref(), "can-close")
    }

    #[doc(alias = "can-close")]
    fn set_can_close(&self, can_close: bool) {
        ObjectExt::set_property(self.as_ref(), "can-close", can_close)
    }

    fn gicon(&self) -> Option<gio::Icon> {
        ObjectExt::property(self.as_ref(), "gicon")
    }

    #[doc(alias = "icon-name")]
    fn icon_name(&self) -> Option<glib::GString> {
        ObjectExt::property(self.as_ref(), "icon-name")
    }

    fn manager(&self) -> Option<DockManager> {
        ObjectExt::property(self.as_ref(), "manager")
    }

    fn set_manager<P: IsA<DockManager>>(&self, manager: Option<&P>) {
        ObjectExt::set_property(self.as_ref(), "manager", manager)
    }

    fn title(&self) -> Option<glib::GString> {
        ObjectExt::property(self.as_ref(), "title")
    }

    #[doc(alias = "can-close")]
    fn connect_can_close_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_can_close_trampoline<
            P: IsA<DockWidget>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlDockWidget,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(DockWidget::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::can-close\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_can_close_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "gicon")]
    fn connect_gicon_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_gicon_trampoline<P: IsA<DockWidget>, F: Fn(&P) + 'static>(
            this: *mut ffi::DzlDockWidget,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(DockWidget::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::gicon\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_gicon_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "icon-name")]
    fn connect_icon_name_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_icon_name_trampoline<
            P: IsA<DockWidget>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlDockWidget,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(DockWidget::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::icon-name\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_icon_name_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "manager")]
    fn connect_manager_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_manager_trampoline<P: IsA<DockWidget>, F: Fn(&P) + 'static>(
            this: *mut ffi::DzlDockWidget,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(DockWidget::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::manager\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_manager_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "title")]
    fn connect_title_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_title_trampoline<P: IsA<DockWidget>, F: Fn(&P) + 'static>(
            this: *mut ffi::DzlDockWidget,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(DockWidget::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::title\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_title_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl<O: IsA<DockWidget>> DockWidgetExt for O {}

impl fmt::Display for DockWidget {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("DockWidget")
    }
}
